#if !defined(PWM_DEF_H)
#define PWM_DEF_H 1

/*
 * Eszkoz-specifikus beallitasok:
 *
 * OCR1A port/pin helyzete, a PWM-et vezerlo OCR regiszter neve,
 * a [TIMER1_OVF_vect] megszakitasi vektor nevet az iocanxx.h, 
 * illetve az iom128.h file tartalmazza.
 * A definiciokba belefogjuk atmega8, az atmega16 es atmega32 MCU-kat
 * (iom8.h, iom16.h, iom32.h file-ok)
 */
 
#if defined(__AVR_ATmega128__) || defined(__AVR_AT90CAN128__)
#  define OC1 PB5
#  define DDROC DDRB
#  define OCR OCR1A
#  if !defined(PB5) 		/* Ha a PB5 nem definialt */
#    define PB5 5
#  endif
#  if !defined(TIMSK)		
#    define TIMSK TIMSK1
#  endif

#elif defined(__AVR_ATmega8__)
#  define OC1 PB1
#  define DDROC DDRB
#  define OCR OCR1A

#elif defined(__AVR_ATmega32__) || defined(__AVR_ATmega16__)
#  define OC1 PD5
#  define DDROC DDRD
#  define OCR OCR1A

#endif

//Alapertelmezett makrok.
 
#if !defined(TIMER1_TOP)
#  define TIMER1_TOP 1023	/* 10-bites PWM */
#endif

//Nem-invertalo, 10-bites, fast PWM mod beallitasa
#if !defined(TIMER1_PWM_INIT)
#  define TIMER1_PWM_INIT_A _BV(WGM11) | _BV(WGM10) | _BV(COM1A1)
#  define TIMER1_PWM_INIT_B _BV(WGM12) 
#endif

//A timer 1 frekvencia osztasanak beallitasa CS (Clock Select) bitekkel
//8-as osztas

#if !defined(TIMER1_CLOCKSOURCE)
#  define TIMER1_CLOCKSOURCE _BV(CS11) //| _BV(CS10) //64-es osztas
#endif

#endif /* !defined(PWM_DEF_H) */
