#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

//#include <inttypes.h>//valtozotipusok deklaralasa

#define ONE_HALF_SEC 61

//F_CPU = 8000000

volatile static unsigned char time_count;
//volatile static uint8_t time_count;
//uint8_t time_count;


//PortD inicializalasa
void InitPorts(void) {
  DDRD = 0xFF;
  PORTD = 0xFF;
}


//Idozito inicializalasa
void InitTimer(void) {
//  TCCR0A |= _BV(CS02);//at90can128, orajel-frekvencia osztasa (clk/256)
  TCCR0 |= _BV(CS02);//atmega128, orajel-frekvencia osztasa (clk/256)

//  OCR0A = 0;//at90can128
  OCR0 = 0;//atmega128

  TCNT0 = 0;
//  TIMSK0 |= _BV(TOIE0);//at90can128, _BV(TOIE) -> (1 << TOIE)
  TIMSK |= _BV(TOIE0);//atmega128, _BV(TOIE) -> (1 << TOIE)   
  
  time_count = 0;
}


ISR(TIMER0_OVF_vect) {
  ++time_count;
  
  if (time_count == ONE_HALF_SEC) {
    PORTD ^= _BV(PD4);
	time_count = 0;
  }	
}


int main(void) {
  cli();//Globalis megszakitasok tiltasa
  
  InitPorts();//PortD inicializalasa
  InitTimer();//Idozito inicializalasa
  
  _delay_ms(100);//Kesleltetes az idozito szamara

  sei();//Globalis megszakitasok engedelyezese

  for (;;) {
  }  
  
  return(0);
}
