#include <avr/io.h>
#include <avr/interrupt.h>
#include <inttypes.h>

#define ONE_SEC 100

volatile static uint8_t time_count;  // counts overflows

void InitPorts (void) {
	DDRD = 0xFF; //PortD osszes kivezetese kimenet
	PORTD = 0xFF; //PortD adatregiszterenek minden bitje 1-es
	PORTD &= ~_BV(PD2); //PortD adatregiszterenek 2. bitjet 0-zasa
}


void InitTimer (void) {
//	TCCR0A = 0x05; //A TIMER0 orajelenek beallitasa clk/1024 ertekre
    TCCR0 |= (_BV(CS02) | _BV(CS01) | _BV(CS00));//atmega128, orajel-frekvencia osztasa (clk/1024)

//	OCR0A = 0x00; //Az OCR0A regiszter tartalmat inicializaljuk, de nem hasznaljuk
    OCR0 = 0; //atmega128

//	TIMSK0 = 0x01; //A TIMER0 tulcsordalasi megszakitasanak engedelyezese
    TIMSK |= _BV(TOIE0);//atmega128, _BV(TOIE) -> (1 << TOIE)   

	TCNT0 = 177; // set TCNT0 to start at 100 giving 156 counts to overflow

	time_count = 0;  //A ciklusszamlalo erteket 0-ra allitjuk
}


ISR (TIMER0_OVF_vect) {
	TCNT0 = 177;  //Az idozito kezdoertekenek beallitasa
	++time_count;  //A ciklusszamlalo tartalmanak novelese
	
	//Elertuk az 1 s-et?
	if (time_count == ONE_SEC) {
      PORTD ^= (_BV(PD2) | _BV(PD5));		
      time_count = 0; //A ciklusszamlalo tartalmanak torlese
  	}
}



int main(void) {
  cli(); //Globalis megszakitasok tiltasa

  InitPorts(); //PortD inicializalasa
  InitTimer(); //A 0. -as idozito inicializalasa
  
  sei(); //Globalis megszakitasok engedelyezese

//vegtelen ciklus
  while (1) {
   
  }
	
  return 0;
}
