#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#define ONE_HALF_SEC 61
#define ONE_SEC 122
#define TWO_SEC 244
//#define FOUR_SEC 2

//F_CPU = 8000000

volatile static unsigned char time_countA, time_countB, time_countC;
//volatile static unsigned char time_countD;


void InitPorts(void) {
  DDRD = 0xFF;
  PORTD = 0xFF;
}


void InitTimer(void) {
//Idozito CTC (clear timer on compare match) uzemmodban
//orajel-frekvencia osztas CLK/256
  TCCR1B |= (_BV(CS12) | _BV(WGM12));
  
  
/*
//16 bites registerek  
  OCR1AH = 0;
  OCR1AL = 255;

  OCR1BH = 0;
  OCR1BL = 255;

  OCR1CH = 0;
  OCR1CL = 255;

  
  TCNT1H = 0;
  TCNT1L = 0;
*/

//Az idozito regiszterei hasznalhatoak 8 bitesen is
  OCR1A = 255;
  OCR1B = 255;
  OCR1C = 255;
  TCNT1 = 0;
  
//AT90CAN128 MCU eseten
//  TIMSK1 |= (_BV(OCIE1A) | _BV(OCIE1B) | _BV(OCIE1C));


//ATMEGA128 MCU eseten  
  TIMSK |= (_BV(OCIE1A) | _BV(OCIE1B));
  ETIMSK |= _BV(OCIE1C);
 
  time_countA = time_countB = time_countC = 0;
//  time_countD = 0;
}


ISR(TIMER1_COMPA_vect) {
  ++time_countA;
  
  if (time_countA == ONE_HALF_SEC) {
    PORTD ^= _BV(PD5);
	time_countA = 0;
  }	
}


ISR(TIMER1_COMPB_vect) {
  ++time_countB;
  
  if (time_countB == ONE_SEC) {
    PORTD ^= _BV(PD4);
	time_countB = 0;
  }	
}


ISR(TIMER1_COMPC_vect) {
  ++time_countC;
  
  if (time_countC == TWO_SEC) {
    PORTD ^= _BV(PD3);

/*	
	++time_countD;
	if (time_countD == FOUR_SEC) {
	  PORTD ^= _BV(PD2);
	  time_countD = 0;
	}
*/
	
	time_countC = 0;
  }	
}



int main(void) {
  cli();
  
  InitPorts();
  InitTimer();

  _delay_ms(100);
  
  sei();
  
  for (;;) {
  }  
  
  return(0);
}
